void Interrupt(void)
{
	while (PIR1bits.RCIF) checkusart();
}

void CheckUsart(void)
{
	PIR1bits.RCIF=0;
	//Set data RX LED on
	
	//IH_Check_HW_Overrun
	if(RCSTAbits.OERR)
	{
		//IH_HW_Overrun
		RCSTAbits.CREN=0;
		RCSTAbits.CREN=1;		//Reset UART
		Flag.DMX_ERROR=1;		//Set flag
		//Set data error LED on
	}
	//IH_Check_9th_Bit
	IH_Timer_Count=0;
	if(RCSTAbits.RX9D==1)
	{
		//IH_Check_SW_Oerrun
		if(RCSTAbits.FERR)
		{
			RCSTAbits.CREN=0;
			RCSTAbits.CREN=1;		//Reset UART
			Flag.DMX_ERROR=1;		//Set flag
			//Set data error LED on
		}
		//IH_Test_Flags
		if(Iflag.VALID_CHANNEL)
		{
			//IH_VALID_CHANNEL
			dmx_buffer[IH_Channels_Received]=RCREG;
			IH_Channels_Received++;
			if(IH_Channels_Received==CHANNELS)
			{
				Iflag=0;
				//Data_RX_Led=1
				flag.DMX_DATA=1;
				return;
			}
		}
		if(Iflag.START_DETECTED)
		{
			//IH_WAIT_CHANNEL
			IH_Channel_Count++;
			if(IH_Channel_Counter!=DMX_Start_Addr) return; 	//Exit
			Iflag.VALID_CHANNEL=1;
			dmx_buffer[0]=RCREG;
			IH_Channels_Received++;
			return;
		}
		if(Iflag.BREAK_DETECTED)
		{
			//IH_WAIT_START
			IH_Channels_Received=0;
			IH_Channel_Count=0;
			if(RCREG==0)
			{
				Iflag.START_DETECTED=1;
			}else{
				Iflag=0;
				return;			//Exit
			}
		}
	}else{
		//IH_Wait_Break
		Iflag=0;
		if((RCSTAbits.RX9D==0) && (RCREG==0)) Iflag.BREAK_DETECTED=1;
		return;
	}
}